(  calc.app )
( Split large file into 800 line hunks )

128 constant len

variable fin
variable inbuf    512 allot
variable fout
variable outbuf   512 allot
variable lines    5000 allot
variable l#     		( line # )
variable base_name 128 allot
variable ext 	   128 allot
variable out.file  128 allot
variable version   
variable hold.break 128 allot
variable line.count
variable toc.fd
variable toc.file   128 allot

			( break out filename parts    )	
: split.filename	( 'string --- )
   base_name 80 0 fill
   fnsplit 
   drop drop 			( get rid of drive & dir )
   base_name swap strcpy
   drop
   ext " .htm" strcpy
   ;

: next.file
   version @ here c! 0 here 1+ c!
   out.file base_name strcpy 
   out.file here strcat 
   out.file ext strcat
   ;

: 'line		( n --- addr )
   len *		( calc offset to line # )
   lines +		( calc address of line  )
   ;
: open.toc
   toc.file base_name strcpy 
   toc.file " .toc"  strcat 
   toc.file WRITE fopen toc.fd !
   ;
: next.line
   inbuf 256 fin @ fgets
\   inbuf dup count -trailing
\   swap drop swap c!
   ;
: wrt.line	( 'string --- )
   fout @ fputs drop toc.fd @ fcr ;
: html.header
   " <HTML>" wrt.line
   " <HEAD>" wrt.line
   " <title>  </title>" wrt.line
   " <body>" wrt.line
   ;
: html.trailer
   " </body>" wrt.line
   " </html>" wrt.line
   ;
: usage
   ." Need two file names ! " cr
   ;

: init
   0 hold.break !
   0 line.count !
   0 l# !
   argc 3 = 0=
   if ( not three args )
     usage
     key drop
   then
   ascii A version c!
   argv 4 + @ READ  fopen   fin  !	( Open input file, argv[1]    ) 
   argv 8 + @ 				( Get addr of argv[2]         )
   split.filename next.file
   out.file   WRITE fopen   fout !
   open.toc
   lines 5000 0 fill
   ;
: >here                 ( 'string --- 'here )  ( copy string to here )
   here 20 0 fill
   count here swap cmove
   here
   ;
: start.new.file
." START New File" cr cr
   ;
: dump.lines
  l# @ 
  0 do
     i 'line fout @ fputs drop
  loop
  0 l# !
  ; 
: store.line
   inbuf dup c@ l# @ 'line swap cmove
   1 l# +!
   ;
: process.line
   1 line.count +!
   inbuf count type
   inbuf 1+ " <HR>" 4 strncmp 0=	( test for match line tag to break)
   inbuf 1+ " <hr>" 4 strncmp 0= or	( test for match line tag to break)
   if ( got one )
     ." >>>>>>>>>>got one" cr
     store.line		\ store the current line
     dump.lines		\ write record to disk
     line.count @ 800 >
     if ( line count > 800 )
       start.new.file
       0 line.count !
     then
   else
." *"
     store.line
   then
   ;
: cleanup
   dump.lines
   html.trailer
   toc.fd @ fclose
   fin    @ fclose
   fout   @ fclose
   ;
: copy.file
   init
   begin
     next.line
     if
       process.line
       false
     else
       true
     then
   until
   cleanup
   ;

